REM '****************************************************
REM '   EC_CONTROL.BAS
REM '        EC   "1"
REM '****************************************************


REM '****************************************************
[INIT_EC]
AT 64:LPRINT "Init EC MODULE  ":PUMP_2_OFF:PUMP_3_OFF
REM '   5 CEK
PUMP_4_OFF:SPRINT "1MD0":PAUSE 50:SPRINT "1IT5"
PAUSE 6000:GOSUB [GET_EC]
GOTO [GET_EC_TEMP]
REM 'RETURN *********************************************


REM '****************************************************
REM ' E -   EC 00.00- 10.00; 99.99 - ERROR
REM '  
[GET_EC]
SPRINT "1GT0":PAUSE 50:SGET #(700)
IF #(700)=0 THEN E=9999:RETURN
#(765)=INSTR${$(700),"E="}
IF #(765)=0 THEN E=9999:RETURN
#(765)=#(765)+2:E=VAL{$(700),#(765)}:E=E/10:RETURN
REM '****************************************************

REM '****************************************************
REM ' B -      EC
REM '    A = 00.0- 50.0; 99.9 - ERROR
[GET_EC_TEMP]
SPRINT "1GT1":PAUSE 50:SGET #(700)
IF #(700)=0 THEN B=999:RETURN
#(765)=INSTR${$(700),"T="}
IF #(765)=0 THEN B=999:RETURN
#(765)=#(765)+2:B=VAL{$(700),#(765)}
IF B>500 THEN B=999:RETURN 
RETURN
REM '****************************************************

REM '****************************************************
[EC_WORK]
REM '#(610) - 0 -  1 - ( )
REM '  ,   ? 
IF #(610)=1 THEN GOTO [EC_WORK_1]
REM '  ,    
#(650)=0:PUMP_2_OFF:PUMP_3_OFF
IF #(612)=3 THEN PUMP_4_OFF
RETURN

REM '#(611) - 0 -  1 - ( PH)
[EC_WORK_1]
IF 0=TIMER{2} THEN #(611)=1
IF #(611)=1 THEN GOTO [EC_WORK_GO]
#(650)=6:PUMP_2_OFF:PUMP_3_OFF
IF #(612)=3 THEN PUMP_4_OFF
RETURN

REM '****************************************
[EC_WORK_GO]

REM ' 
IF #(650)=0 THEN #(650)=1


IF #(650)<>5 THEN IF #(650)<>1 THEN GOTO [EC_WORK_GO_1]
REM ' #(650)=1 -  ,    
REM '     5     
REM '   
=SEC{}:IF 0<>%5 THEN #(656)=0:RETURN 

[EC_WORK_GO_ST]
IF #(656)=1 THEN RETURN
#(656)=1:GOSUB [GET_EC]
IF E>9000 THEN RETURN
IF E>=F THEN IF E<=G THEN #(650)=1:RETURN

IF E<F THEN GOTO [EC_WORK_GO_MIN]
REM '    - 
REM '   =2 -      
REM ' U -     EC  
GOSUB [TANK_ADD_WATER]
REM '#(609) -   
REM '       - 0 -  1 - 
IF #(614)=1 THEN GOSUB [TANK_ENABLE_MIX]
IF #(650)=5 THEN #(650)=2:RETURN 
#(650)=2
REM '#(613) -   
REM '       - 0 -  1 -  
IF #(613)=1 THEN GOSUB [POLIW_BLOCK]
RETURN 

REM '****************************************************
[EC_WORK_GO_1]
IF #(650)=2 THEN RETURN
IF #(650)<>3 THEN GOTO [EC_WORK_GO_2]
REM '   TIMER_6    TANK ADD WATER
REM ' V -     EC  
TIMER 6,V:#(650)=4:RETURN

REM '****************************************************
[EC_WORK_GO_2]
REM '   =4 -    
IF #(650)<>4 THEN GOTO [EC_WORK_GO_3]
IF 0<>TIMER{6} THEN RETURN
#(650)=5:RETURN

REM '    -  
[EC_WORK_GO_MIN]
IF #(614)=1 THEN GOSUB [TANK_ENABLE_MIX]
REM '#(613) -   
REM '       - 0 -  1 -  
IF #(650)<>5 THEN IF #(613)=1 THEN GOSUB [POLIW_BLOCK] 
REM '    
REM ' O -   EC  10 
REM ' Q -  1  EC  
REM '   TIMER_4    EC
#(650)=7:=O*Q/10:TIMER 4,:PUMP_2_ON:RETURN

REM '****************************************************
[EC_WORK_GO_3]
IF #(650)<>7 THEN GOTO [EC_WORK_GO_4]
IF 0<>TIMER{4} THEN RETURN
REM '#(612) - 2     #2  #3    
REM '         1     #2
REM '         3     #2  #3  #4
PUMP_2_OFF
REM ' P -   EC
IF #(612)=1 THEN #(650)=10:TIMER 4,P:RETURN

REM ' R -  2  EC
REM ' O -   EC  10 
=O*R/10:TIMER 4,:PUMP_3_ON:#(650)=8:RETURN

REM '****************************************************
[EC_WORK_GO_4]
IF #(650)<>8 THEN GOTO [EC_WORK_GO_5]
IF 0<>TIMER{4} THEN RETURN
REM '#(612) - 2     #2  #3    
REM '         1     #2
REM '         3     #2  #3  #4
PUMP_3_OFF
REM ' P -   EC
IF #(612)=2 THEN #(650)=10:TIMER 4,P:RETURN

REM ' S -  3  EC
REM ' O -   EC  10 
=O*S/10:TIMER 4,:PUMP_4_ON:#(650)=9:RETURN

REM '****************************************************
[EC_WORK_GO_5]
IF #(650)<>9 THEN GOTO [EC_WORK_GO_6]
IF 0<>TIMER{4} THEN RETURN
REM ' P -   EC
PUMP_4_OFF:#(650)=10:TIMER 4,P:RETURN

REM '****************************************************
[EC_WORK_GO_6]
IF 0<>TIMER{4} THEN RETURN
#(650)=5:GOTO [EC_WORK_GO_ST]
REM '****************************************************






REM '****************************************************
[MENU_EC]

REM '      EC
REM '#(610) - 0 -  1 - ( )

REM '#(612) - 2     #2  #3    
REM '         1     #2
REM '         3     #2  #3  #4

REM '#(613) -   
REM '       - 0 -  1 - 
REM '#(614) -   
REM '       - 0 -  1 - 

[MENU_EC_1]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_1]  
LPRINT " EC":AT 64:LPRINT ""
AT 64:IF #(610)=1 THEN LPRINT " "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_2]
#(610)=((!#(610))&1):GOTO [MENU_EC_1]

[MENU_EC_2]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_2]  
LPRINT ". ":AT 64:LPRINT "EC  "
AT 64:IF #(612)=1 THEN LPRINT "EC        "
IF #(612)=3 THEN LPRINT "EC        "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_3]
#(612)=#(612)+1:IF #(612)>3 THEN #(612)=1
GOTO [MENU_EC_2]


[MENU_EC_3]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_3]  
LPRINT ". ":AT 64:LPRINT "EC  ."
AT 64:IF #(613)=1 THEN LPRINT "EC  . "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_4]
#(613)=((!#(613))&1):GOTO [MENU_EC_3]

[MENU_EC_4]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_4]  
LPRINT "..":AT 64:LPRINT "EC - : ."
AT 74:IF #(614)=1 THEN LPRINT ". "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_5]
#(614)=((!#(614))&1):GOTO [MENU_EC_4]




REM ' O -   EC  10 
REM ' P -   EC
REM ' Q -  1  EC
REM ' R -  2  EC
REM ' S -  3  EC

REM ' U -     EC  
REM ' V -     EC  

[MENU_EC_5]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_5]
LPRINT " 10/10":AT 64:LPRINT "  ",O," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_6]
i=O:GOSUB [CHANGE_PARAM]
O=i:GOTO [MENU_EC_5]

[MENU_EC_6]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_6]
LPRINT ".  EC":AT 64:LPRINT "  ",P," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_7]
i=P:GOSUB [CHANGE_PARAM]
P=i:GOTO [MENU_EC_6]

[MENU_EC_7]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_7]
LPRINT " - #1":AT 64:LPRINT "  ",Q,"/10"
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_8]
i=Q:GOSUB [CHANGE_PARAM]
Q=i:GOTO [MENU_EC_7]

[MENU_EC_8]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_8]
LPRINT " - #2":AT 64:LPRINT "  ",R,"/10"
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_9]
i=R:GOSUB [CHANGE_PARAM]
R=i:GOTO [MENU_EC_8]

[MENU_EC_9]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_9]
LPRINT " - #3":AT 64:LPRINT "  ",S,"/10"
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_10]
i=S:GOSUB [CHANGE_PARAM]
S=i:GOTO [MENU_EC_9]

REM ' U -     EC  
REM ' V -     EC  
[MENU_EC_10]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_10]
LPRINT ". . ":AT 64:LPRINT "EC ",U," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_11]
i=U:GOSUB [CHANGE_PARAM]
U=i:GOTO [MENU_EC_10]

[MENU_EC_11]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_11]
LPRINT ". . ":AT 64:LPRINT "EC ",V," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_12]
i=V:GOSUB [CHANGE_PARAM]
V=i:GOTO [MENU_EC_11]

[MENU_EC_12]
REM ' F -   EC
REM ' G -   EC
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_12]
LPRINT " EC":AT 70:IF F>1000 THEN F=1000
LPRINT .2,F:#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_13]
i=F:GOSUB [CHANGE_PARAM]
F=i:GOTO [MENU_EC_12]

[MENU_EC_13]

REM ' F -   EC
REM ' G -   EC
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_EC_13]
LPRINT " EC":AT 70:IF G>1000 THEN G=1000
LPRINT .2,G:#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_EC_14]
i=G:GOSUB [CHANGE_PARAM]
G=i:GOTO [MENU_EC_13]


[MENU_EC_14]

GOSUB [SAVE_CONFIG]

DATA $(770),".EC 1413":DATA $(790),"1CL0":GOSUB [KALIBR_EC_SUB]
IF i=0 THEN RETURN
DATA $(770),".EC 5000":DATA $(790),"1CL1":GOSUB [KALIBR_EC_SUB]
IF i=0 THEN RETURN
DATA $(770),".EC 12880":DATA $(790),"1CL2":GOTO [KALIBR_EC_SUB]
REM 'RETURN*********************************************


[KALIBR_EC_SUB]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [KALIBR_EC_SUB]
LPRINT *$(770):PAUSE 1000:CLS:GOSUB [GET_EC]
LPRINT .2,%4,"EC=",E:AT 64:LPRINT "Ok-,->"  
#(765)=KEY{30}:IF #(765)=0 THEN i=0:RETURN
IF #(765)=4 THEN i=1:RETURN
IF #(765)<>1 THEN GOTO [KALIBR_EC_SUB]
SPRINT *$(790):CLS:LPRINT "Ok":PAUSE 1000:GOTO [KALIBR_EC_SUB]




