REM '****************************************************
REM '   PH_CONTROL.BAS
REM '        PH   "0"
REM '****************************************************

REM '****************************************************
[INIT_PH]
AT 64:LPRINT "Init PH MODULE  ":PUMP_1_OFF:PUMP_4_OFF
REM '   5 CEK
SPRINT "0MD0":PAUSE 100:SPRINT "0IT5":PAUSE 6000 
GOSUB [GET_PH]
GOTO [GET_PH_TEMP]
REM 'RETURN *********************************************

REM '****************************************************
REM ' H -   PH 00.00- 15.00; 99.99 - ERROR
REM '  
[GET_PH]
SPRINT "0GT0":PAUSE 50:SGET #(700)
IF #(700)=0 THEN H=9999:RETURN
#(765)=INSTR${$(700),"H="}
IF #(765)=0 THEN H=9999:RETURN
#(765)=#(765)+2:H=VAL{$(700),#(765)}:RETURN
REM '****************************************************

REM '****************************************************
REM ' A -      PH
REM '    A = 00.0- 50.0; 99.9 - ERROR
[GET_PH_TEMP]
SPRINT "0GT1":PAUSE 50:SGET #(700)
IF #(700)=0 THEN A=999:RETURN
#(765)=INSTR${$(700),"T="}:#(765)=#(765)+2
IF #(765)=2 THEN A=999:RETURN
A=VAL{$(700),#(765)}:IF A>500 THEN A=999:RETURN 
RETURN
REM '****************************************************

REM '****************************************************
[PH_WORK]
REM ' DEBUG
REM 'PAUSE 100:=TIMER{3}:PRINT #(651),"-",

REM '  ,   ? 
IF #(606)=1 THEN GOTO [PH_WORK_GO]
REM '  ,    
#(651)=0:PUMP_1_OFF
IF #(607)=0 THEN IF #(612)<>3 THEN PUMP_4_OFF
RETURN

REM '****************************************
[PH_WORK_GO]
REM ' 
IF #(651)=0 THEN #(651)=1
IF #(651)<>4 THEN IF #(651)<>1 THEN GOTO [PH_WORK_GO_1]

REM '  #(651)=1 OR =4 -  ,    
REM '     5     
REM '   
=SEC{}:IF 0<>%5 THEN #(655)=0:RETURN 
REM '   5 
[PH_WORK_GO_ST]
IF #(655)=1 THEN RETURN
#(655)=1:GOSUB [GET_PH]
IF H>9000 THEN RETURN

CASE #(607),0,[PH_START_0],1,[PH_START_1],2,[PH_START_2]:RETURN
REM 'RETURN 
REM '****************************************
REM '#(607) - 0   #1  #4 
REM '   TIMER_3    PH
[PH_START_0]
IF H>J THEN PUMP_1_ON:TIMER 3,K:GOTO [PH_START_0_1]
IF H<I THEN PUMP_4_ON:TIMER 3,M:GOTO [PH_START_0_1]
REM '#(611) - 0 -  1 - ( PH)
#(651)=1:#(611)=1:RETURN
REM '************************
REM '         1   #1  
[PH_START_1]
IF H>J THEN PUMP_1_ON:TIMER 3,K:GOTO [PH_START_0_1]
#(651)=1:#(611)=1:RETURN
REM '************************
REM '         2   #1   
[PH_START_2]
IF H<I THEN THEN PUMP_1_ON:TIMER 3,K:GOTO [PH_START_0_1]
#(651)=1:#(611)=1:RETURN
REM '****************************************
[PH_START_0_1]
REM '#(609) -   
REM '       - 0 -  1 - 
IF #(609)=1 THEN GOSUB [TANK_ENABLE_MIX]
REM '   - 
IF #(651)=4 THEN #(651)=2:RETURN 
REM '   1   " "
#(651)=2
REM '#(608) -   
REM '       - 0 -  1 -  
IF #(608)=1 THEN GOSUB [POLIW_BLOCK]
REM '#(611) - 0 -  1 - ( PH)
REM ' X -     EC - 
REM '	TIMER_2     EC
#(611)=0:TIMER 2,X:RETURN 



REM '****************************************************
[PH_WORK_GO_1]
REM '   
IF #(651)<>2 THEN GOTO [PH_WORK_GO_2] 
IF 0<>TIMER{3} THEN RETURN
CASE #(607),0,[PH_START_0A],1,[PH_START_1A],2,[PH_START_1A]:RETURN
REM 'RETURN 

[PH_START_0A]
IF 1=PUMP_1_IN THEN TIMER 3,L:PUMP_1_OFF
IF 1=PUMP_4_IN THEN TIMER 3,N:PUMP_4_OFF
#(651)=3:RETURN 

[PH_START_1A]
TIMER 3,L:PUMP_1_OFF:#(651)=3:RETURN 

REM '****************************************************
[PH_WORK_GO_2]
IF 0<>TIMER{3} THEN RETURN
#(651)=4:GOTO [PH_WORK_GO_ST]
REM '****************************************************



REM '****************************************************
[MENU_PH]
REM '       PH
REM '#(606) - 0 -  1 - ( )
REM '#(607) - 0   #1  #4   
REM '         1   #1   
REM '         2   #1   
REM '#(608) -   
REM '       - 0 -  1 - 
REM '#(609) -   
REM '       - 0 -  1 - 
[MENU_PH_1]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_1]  
LPRINT " PH":AT 64:LPRINT ""
AT 64:IF #(606)=1 THEN LPRINT " "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_2]
#(606)=((!#(606))&1):GOTO [MENU_PH_1]

[MENU_PH_2]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_2]  
LPRINT ". ":AT 64:LPRINT "PH  "
AT 64:IF #(607)=1 THEN LPRINT "  ."
IF #(607)=2 THEN LPRINT "  ."
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_3]
#(607)=#(607)+1:IF #(607)>2 THEN #(607)=0
GOTO [MENU_PH_2]

[MENU_PH_3]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_3]  
LPRINT ". ":AT 64:LPRINT "PH ."
AT 64:IF #(608)=1 THEN LPRINT "PH . "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_4]
#(608)=((!#(608))&1):GOTO [MENU_PH_3]


[MENU_PH_4]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_4]  
LPRINT "..":AT 64:LPRINT "PH - : "
IF #(609)=0 THEN LPRINT "."
IF #(609)=1 THEN LPRINT "."
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_5]
#(609)=((!#(609))&1):GOTO [MENU_PH_4]

REM ' K -     1  PH ()
REM ' L -     1  PH ()
REM ' M -     2  PH 
REM ' N -     2  PH 
REM ' X -     EC - 
[MENU_PH_5]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_5]
LPRINT ".  #1":AT 64:LPRINT "PH ",K," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_6]
i=K:GOSUB [CHANGE_PARAM]
K=i:GOTO [MENU_PH_5]

[MENU_PH_6]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_6]
LPRINT ".  #1":AT 64:LPRINT "PH ",L," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_7]
i=L:GOSUB [CHANGE_PARAM]
L=i:GOTO [MENU_PH_6]

[MENU_PH_7]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_7]
LPRINT ".  #2":AT 64:LPRINT "PH ",M," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_8]
i=M:GOSUB [CHANGE_PARAM]
M=i:GOTO [MENU_PH_7]

[MENU_PH_8]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_8]
LPRINT ".  #2":AT 64:LPRINT "PH ",N," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_9]
i=N:GOSUB [CHANGE_PARAM]
N=i:GOTO [MENU_PH_8]

REM ' X -     EC - 
[MENU_PH_9]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_9]
LPRINT ". EC ":AT 64:LPRINT "  ",X," "
#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_10]
i=X:GOSUB [CHANGE_PARAM]
X=i:GOTO [MENU_PH_9]

REM ' I -   PH
REM ' J -   PH 
[MENU_PH_10]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_10]
LPRINT " PH":AT 70:IF I>1500 THEN I=1500
LPRINT .2,I:#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_11]
i=I:GOSUB [CHANGE_PARAM]
I=i:GOTO [MENU_PH_10]

[MENU_PH_11]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [MENU_PH_11]
LPRINT " PH":AT 70:IF J>1500 THEN J=1500
LPRINT .2,J:#(765)=KEY{15}:IF #(765)=0 THEN RETURN
IF #(765)=4 THEN GOTO [MENU_PH_12]
i=J:GOSUB [CHANGE_PARAM]
J=i:GOTO [MENU_PH_11]

[MENU_PH_12]
GOSUB [SAVE_CONFIG]

DATA $(770),".PH 7.01":DATA $(790),"0CL4":GOSUB [KALIBR_PH_SUB]
IF i=0 THEN RETURN
DATA $(770),".PH 4.01":DATA $(790),"0CL6":GOSUB [KALIBR_PH_SUB]
IF i=0 THEN RETURN
DATA $(770),".PH 10.01":DATA $(790),"0CL7":GOTO [KALIBR_PH_SUB]
REM 'RETURN ***********************************************


[KALIBR_PH_SUB]
CLS:PAUSE 100:IF 0<>GKEY{} THEN GOTO [KALIBR_PH_SUB]
LPRINT *$(770):PAUSE 1000:CLS:GOSUB [GET_PH]
LPRINT .2,%4,"PH=",H:AT 64:LPRINT "Ok-,->"  
#(765)=KEY{30}:IF #(765)=0 THEN i=0:RETURN
IF #(765)=4 THEN i=1:RETURN
IF #(765)<>1 THEN GOTO [KALIBR_PH_SUB]
SPRINT *$(790):CLS:LPRINT "Ok":PAUSE 1000:GOTO [KALIBR_PH_SUB]





